<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:rich="http://richfaces.org/rich" xmlns:f="http://java.sun.com/jsf/core" xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j" xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
  <ui:define name="body">
    <h:form id="globform" enctype="multipart/form-data">
      <h1>#{messages['net.ihe.gazelle.cdagen.EDispensationGeneration']}</h1>
      <gri:panel>
        <f:facet name="header">#{messages['net.ihe.gazelle.cdagen.GenerateEDispensation']}</f:facet>
        <gri:tabPanel withBorder="true">
        	<gri:tab head="#{messages['net.ihe.gazelle.cdagen.Prescription']}" id="Prescription">
        		<s:div id="uploaddiv">
	              <s:decorate id="filetyped" template="/layout/form/_edit.xhtml">
	                <ui:define name="label">#{messages['net.ihe.gazelle.cdagen.CDAType']}</ui:define>
	                <h:selectOneMenu id="listcdatype" value="#{eDispGeneratorManager.cdaType}">
	                  <s:selectItems value="#{eDispGeneratorManager.listCDATypes()}" var="currcdatype" label="#{currcdatype.value}"/>
	                </h:selectOneMenu>
	              </s:decorate>
	              <h:outputText value="#{messages['net.ihe.gazelle.cdagen.EPrescriptionFile']}" />
	              <br/>
                  <rich:fileUpload fileUploadListener="#{eDispGeneratorManager.uploadListener}" acceptedTypes="xml" maxFilesQuantity="1" 
                  	id="uploadFile" immediateUpload="true"  listWidth="width: inherit;" listHeight="60px">
                    <a4j:ajax event="uploadcomplete" render="uploaddiv" execute="@this"/>
                  </rich:fileUpload>
                  <h:message for="uploadFile"/>
                  <br/>
	              <s:div rendered="#{(eDispGeneratorManager.fichPresc.name != null) and (eDispGeneratorManager.fichPresc.name.length() != 0)}" id="filupdd">
	                  <h:outputText value="#{messages['net.ihe.gazelle.cdagen.FileUploaded']} " style="font-weight: bold;"/>
	                  <h:outputText value="#{eDispGeneratorManager.fichPresc.name}"/>
	              </s:div>
	              <s:div id="prescdivv" rendered="#{eDispGeneratorManager.ePrescription != null}">
	                <s:div id="buttondivep1">
									<a4j:commandButton
										value="#{messages['net.ihe.gazelle.cdagen.ExternalValidation']}"
										id="xvalidButtonpre2"
										styleClass="gzl-btn-blue"
										actionListener="#{eDispGeneratorManager.validateEPrescription()}"
										oncomplete="jq162('#EPrescResultModal').modal('show');"
										render="EPrescResultModal" />
									<h:selectOneMenu id="valpres1" value="#{eDispGeneratorManager.xmlMetaDataReqForEPresc}" rendered="#{eDispGeneratorManager.ePrescription != null}">
	                    <f:selectItem itemValue="epSOS - ePrescription - Friendly"/>
	                    <f:selectItem itemValue="epSOS - ePrescription - Pivot"/>
	                  </h:selectOneMenu>
	                </s:div>
	                <br/>
	                <h:selectOneRadio value="#{eDispGeneratorManager.ePViewMode}">
	                  <f:selectItem itemLabel="#{messages['net.ihe.gazelle.cdagen.Xml']}" itemValue="xml"/>
	                  <f:selectItem itemLabel="#{messages['net.ihe.gazelle.cdagen.Html1']}" itemValue="html1"/>
	                  <f:selectItem itemLabel="#{messages['net.ihe.gazelle.cdagen.Html2']}" itemValue="html2"/>
	                  <a4j:ajax event="change"  render="prescdivv" execute="@this"/>
	                </h:selectOneRadio>
	                <s:div id="prespresc" style="overflow:auto;width:100%;height:500px;">
	                  <s:div id="epxmlview1" rendered="#{eDispGeneratorManager.ePViewMode.equals('xml')}">
	                    <gdk:insert content="#{eDispGeneratorManager.ePrescription}" highlight="xml" style="width: 1000px; min-height: 500px;"/>
	                  </s:div>
	                  <s:div id="ephtmlview1" rendered="#{eDispGeneratorManager.ePViewMode.equals('html1')}">
												#{eDispGeneratorManager.updateEPView()}
												<iframe src="ePview1.seam" style="width: 90%; min-height: 500px; border-width: 0px;"/>
											</s:div>
	                  <s:div id="ephtml2view1" rendered="#{eDispGeneratorManager.ePViewMode.equals('html2')}">
												#{eDispGeneratorManager.updateEPView()}
												<iframe src="ePview2.seam" style="width: 90%; min-height: 500px;; border-width: 0px;"/>
											</s:div>
	                </s:div>
	              </s:div>
	            </s:div>
        	</gri:tab>
        	<gri:tab head="#{messages['net.ihe.gazelle.cdagen.Author_2']}" id="Author">
						<s:div id="ddsDiv">
							<gri:panel pid="ddsPanel"
								rendered="#{eDispGeneratorManager.displayDDSPanel}">
								<h:selectOneRadio
									value="#{eDispGeneratorManager.ddsDisplayMode}">
									<f:selectItem itemValue="List Authors"
										itemLabel="#{messages['net.ihe.gazelle.cdagen.ListAuthors']}" />
									<f:selectItem itemValue="Generate Author"
										itemLabel="#{messages['net.ihe.gazelle.cdagen.GenerateAuthor_2']}" />
									<a4j:ajax event="change" render="ddsDiv" execute="@this" />
								</h:selectOneRadio>
								<s:div is="selecauth"
									rendered="#{eDispGeneratorManager.ddsDisplayMode.equals('List Authors')}">
									<rich:dataTable value="#{authorManager.authorsFounds}"
										id="patientsListTable" var="patient" rows="10"
										onRowMouseOver="this.style.backgroundColor='#94C2E6';"
										onRowMouseOut="this.style.backgroundColor='#{a4jSkin.tableBackgroundColor}';"
										render="ds">
										<ui:include src="/author/authorColumns.xhtml">
											<ui:param name="patient" value="#{patient}" />
										</ui:include>
										<g:column id="actionColumn">
											<ui:define name="header">#{messages['net.ihe.gazelle.cdagen.Action']}</ui:define>
											<center>
												<a4j:commandLink actionListener="#{eDispGeneratorManager.setSelectedPatientAndUpdateGUI(patient)}"
													render="selectedPatientDiv,ddsDiv">
								                	<span class="gzl-icon-gears" title="#{messages['net.ihe.gazelle.cdagen.SelectThisAuthor']}"></span>
								                </a4j:commandLink>
											</center>
										</g:column>
										<ui:include src="../tableFooter.xhtml" />
									</rich:dataTable>
								</s:div>
								<s:div id="genautho"
									rendered="#{eDispGeneratorManager.ddsDisplayMode.equals('Generate Author')}">
									<f:facet name="header">#{messages['net.ihe.gazelle.cdagen.GenerateAuthor']}</f:facet>
									#{eDispGeneratorManager.initializeListCountry()}
									<ui:include src="/patient/patientGenerator.xhtml">
										<ui:param name="patientGeneratorBean"
											value="#{eDispGeneratorManager}" />
										<ui:param name="displayAllCriteria"
											value="#{messages['net.ihe.gazelle.cdagen.True']}" />
									</ui:include>
									<a4j:commandButton id="generateButton"
										value="#{messages['net.ihe.gazelle.cdagen.GenerateAuthor_2']}"
										actionListener="#{eDispGeneratorManager.generateAndSavePatient()}"
										styleClass="gzl-btn-green" render="selectedPatientDiv, ddsDiv" />
								</s:div>
							</gri:panel>
						</s:div>

				<s:div id="selectedPatientDiv">
	              <gri:panel pid="selectedPatient" rendered="#{eDispGeneratorManager.selectedPatient != null}">
	                <f:facet name="header">#{messages['net.ihe.gazelle.cdagen.CreatedAuthor']}</f:facet>
	                <s:div rendered="#{not eDispGeneratorManager.displayEditPatientPanel}">
	                  <ui:include src="/patient/showPatient.xhtml">
	                    <ui:param name="patient" value="#{eDispGeneratorManager.selectedPatient}"/>
	                    <ui:param name="renderHistory" value="#{messages['net.ihe.gazelle.cdagen.False']}"/>
	                    <ui:param name="renderEncounters" value="#{messages['net.ihe.gazelle.cdagen.False']}"/>
	                  </ui:include>
						<a4j:commandButton id="editPatient"
							styleClass="gzl-btn-blue"
							actionListener="#{eDispGeneratorManager.setDisplayEditPatientPanel(true)}"
							value="#{messages['net.ihe.gazelle.cdagen.ModifyAuthorData']}"
							render="selectedPatientDiv" />
					</s:div>
	                <s:div rendered="#{eDispGeneratorManager.displayEditPatientPanel}">
	                  <ui:include src="/patient/editPatientWithIdManagement.xhtml">
	                    <ui:param name="patient" value="#{eDispGeneratorManager.selectedPatient}"/>
	                    <ui:param name="renderHistory" value="false"/>
	                    <ui:param name="renderEncounters" value="false"/>
	                  </ui:include>
									<a4j:commandButton id="viewPatient"
										styleClass="gzl-btn-blue"
										actionListener="#{eDispGeneratorManager.updateAuthor()}"
										value="#{messages['net.ihe.gazelle.cdagen.ViewAuthor_2']}"
										render="selectedPatientDiv" />
									<br />
								</s:div>
								<a4j:commandButton id="regeneratePatient"
									styleClass="gzl-btn-green"
									actionListener="#{eDispGeneratorManager.displayDDSPanel()}"
									value="#{messages['net.ihe.gazelle.cdagen.GenerateSelectAnotherAuthor']}"
									render="selectedPatientDiv, ddsDiv" />
							</gri:panel>
	            </s:div>
        	</gri:tab>
        	<gri:tab head="#{messages['net.ihe.gazelle.cdagen.Organization']}" id="Organization">
        		<div class="form-horizontal">
        		 <s:decorate id="orgroot" template="/layout/form/_form_field_horizontal_3-9.xhtml">
	              <ui:define name="label">#{messages['net.ihe.gazelle.cdagen.OrgRoot']}</ui:define>
	              <h:inputText value="#{eDispGeneratorManager.organization.root}">
	                <a4j:ajax event="blur" render="orgroot" execute="@this"/>
	              </h:inputText>
	            </s:decorate>
	            <s:decorate id="orgext" template="/layout/form/_form_field_horizontal_3-9.xhtml">
	              <ui:define name="label">#{messages['net.ihe.gazelle.cdagen.OrgExtension']}</ui:define>
	              <h:inputText value="#{eDispGeneratorManager.organization.extension}">
	                <a4j:ajax event="blur" render="orgext" execute="@this"/>
	              </h:inputText>
	            </s:decorate>
	            <s:decorate id="orgname" template="/layout/form/_form_field_horizontal_3-9.xhtml">
	              <ui:define name="label">#{messages['net.ihe.gazelle.cdagen.OrgName']}</ui:define>
	              <h:inputText value="#{eDispGeneratorManager.organization.assigningAuthorityName}">
	                <a4j:ajax event="blur" render="orgname" execute="@this"/>
	              </h:inputText>
	            </s:decorate>
	            </div>
        	</gri:tab>
        </gri:tabPanel>
        <br/>
				<a4j:commandButton
					styleClass="gzl-btn-green"
					value="#{messages['net.ihe.gazelle.cdagen.Dispense']}" id="genbutt"
					action="#{eDispGeneratorManager.generateDispensation()}"
					render="messages,epeddiv" />
				<br/>
        <s:div id="epeddiv">
          <s:div rendered="#{eDispGeneratorManager.eDispensation != null}">
            <h:panelGrid columns="2" id="buttondiv">
							<a4j:commandButton
								value="#{messages['net.ihe.gazelle.cdagen.ExternalValidation']}"
								id="xvalidButton"
								styleClass="gzl-btn-blue"
								actionListener="#{eDispGeneratorManager.validateEDispensation()}"
								oncomplete="jq162('#EDispResultModal').modal('show');"
								render="EDispResultModal" />
			  <h:selectOneMenu id="val" value="#{eDispGeneratorManager.xmlMetaDataReqForEDisp}">
                <f:selectItem itemValue="epSOS - eDispensation - Friendly"/>
                <f:selectItem itemValue="epSOS - eDispensation - Pivot"/>
              </h:selectOneMenu>
            </h:panelGrid>
            <br/>
            <h:selectOneRadio value="#{eDispGeneratorManager.eDViewMode}">
              <f:selectItem itemLabel="#{messages['net.ihe.gazelle.cdagen.Xml']}" itemValue="xml"/>
              <f:selectItem itemLabel="#{messages['net.ihe.gazelle.cdagen.Html']}" itemValue="html"/>
              <a4j:ajax event="change"  render="epeddiv" execute="@this"/>
            </h:selectOneRadio>
            <s:div id="edxmlview" rendered="#{eDispGeneratorManager.eDViewMode.equals('xml')}">
              <gdk:insert content="#{eDispGeneratorManager.eDispensation}" highlight="xml" style="width: 1000px;"/>
            </s:div>
            <s:div id="edhtmlview" rendered="#{eDispGeneratorManager.eDViewMode.equals('html')}">
							#{eDispGeneratorManager.updateEDView()}
							<iframe src="eDview1.seam" style="width: 100%; min-height: 700px; border-width: 0px;"/>
						</s:div>
          </s:div>
        </s:div>
      </gri:panel>
      <!-- detail Result Modal -->
      <gri:popupPanel id="EDispResultModal" width="900" height="600">
        <f:facet name="header">
          <h:outputText value="#{messages['net.ihe.gazelle.cdagen.DetailedResult']}"/>
        </f:facet>
        <f:facet name="controls">
          <h:graphicImage alt="#{messages['net.ihe.gazelle.cdagen.Close']}" value="/img/modal/close.gif" style="cursor:pointer" onclick="jq162('#EDispResultModal')}.hide()"/>
        </f:facet>
        <s:decorate id="driddecdisp" rendered="#{eDispGeneratorManager.eDispensation != null}">
          <div style="overflow: auto; width: 880px; height: 560px;">
            <iframe src="validationResult.seam" style="width: 100%; height: 100%; border-width: 0px;"/>
          </div>
        </s:decorate>
      </gri:popupPanel>
      <!-- detail Result Modal -->
      <gri:popupPanel id="EPrescResultModal" width="900" height="600">
        <f:facet name="header">
          <h:outputText value="#{messages['net.ihe.gazelle.cdagen.DetailedResult']}"/>
        </f:facet>
        <f:facet name="controls">
          <h:graphicImage alt="#{messages['net.ihe.gazelle.cdagen.Close']}" value="/img/modal/close.gif" style="cursor:pointer" onclick="jq162('#EPrescResultModal')}.hide()"/>
        </f:facet>
        <s:decorate id="driddecpresc" rendered="#{eDispGeneratorManager.ePrescription != null}">
          <div style="overflow: auto; width: 880px; height: 560px;">
            <iframe src="validationResult.seam" style="width: 100%; height: 100%; border-width: 0px;"/>
          </div>
        </s:decorate>
      </gri:popupPanel>
    </h:form>
  </ui:define>
</ui:composition>
